//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
#property indicator_chart_window
#property indicator_buffers 4
#property strict

enum enDisplay
{
   dis_all, // Display lines and values
   dis_val, // Display linear regression value only
   dis_lin  // Display linear regression lines only
};
extern int                LrcPeriod    = 50;             // Period for linear regression 
extern ENUM_APPLIED_PRICE LrcPrice     = PRICE_CLOSE;    // Linear regression price
extern int                LrcNo        = 150;            // Number of linear regressions drawn
extern double             Filter       = 0;              // Filter to use on price (<= 0, no filter)
extern int                FilterPeriod = 0;              // Filter period to use (0 to use lrc period)
extern enDisplay          Display      = dis_all;        // Display :
extern color              ColorUp      = clrLimeGreen;   // Color when regression sloping up
extern color              ColorDown    = clrOrangeRed;   // Color when regression sloping down
extern color              ColorShadow  = clrDimGray;     // Color for the shadow line
extern int                LinesWidth   = 3;              // Line graph width
extern int                LinesWidthWhenTrendChange = 2; // Lines width when trend change
extern ENUM_LINE_STYLE    ChannelStyle = STYLE_DOT;      // Channel lines style
extern string             UniqueID     = "Lrs1";         // Indicator unique ID

double lr[],lrda[],lrdb[],shadow[],slope[],trend[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6); 
   int lstyle = DRAW_LINE; if (Display==dis_lin) lstyle=DRAW_NONE;
   SetIndexBuffer(0,shadow); SetIndexStyle(0,lstyle,EMPTY,LinesWidth+4,ColorShadow);
   SetIndexBuffer(1,lr);     SetIndexStyle(1,lstyle,EMPTY,LinesWidth  ,ColorUp);
   SetIndexBuffer(2,lrda);   SetIndexStyle(2,lstyle,EMPTY,LinesWidth  ,ColorDown);
   SetIndexBuffer(3,lrdb);   SetIndexStyle(3,lstyle,EMPTY,LinesWidth  ,ColorDown);
   SetIndexBuffer(4,slope); 
   SetIndexBuffer(5,trend); 
   return(0); 
}
int deinit() 
{ 
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }

return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(MathMax(Bars-counted_bars,LrcNo),Bars-1);

   //
   //
   //
   //
   //
   
   int tperiod = FilterPeriod; if (tperiod<=0) tperiod = LrcPeriod;
   if (slope[limit]==-1) CleanPoint(limit,lrda,lrdb);            
   for (int i=limit; i>=0; i--)
   {
     double tslope,error;
         lr[i]     = iLrValue(iFilter(iMA(NULL,0,1,0,MODE_SMA,LrcPrice,i),Filter,tperiod,i),LrcPeriod,tslope,error,i);
         shadow[i] = lr[i];
         lrda[i]   = EMPTY_VALUE;
         lrdb[i]   = EMPTY_VALUE;
         if (i<Bars-1)
         {
            trend[i] = trend[i+1];
            slope[i] = slope[i+1];
               if (lr[i]>lr[i+1]) slope[i] =  1;
               if (lr[i]<lr[i+1]) slope[i] = -1;
               if (tslope<0) trend[i] = -1;
               if (tslope>0) trend[i] =  1;
         }
         if (slope[i]==-1) PlotPoint(i,lrda,lrdb,lr);
         if (Display!=dis_val && i<(Bars-1) && i<=LrcNo)
            if (trend[i]!=trend[i+1])
                  createLine("",lr[i],lr[i]-tslope*(LrcPeriod-1),i,LinesWidthWhenTrendChange);
            else  createLine("",lr[i],lr[i]-tslope*(LrcPeriod-1),i);
	}
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


#define filterInstances 1
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int instanceNo=0)
{
   if (filter<=0 || period<=0) return(tprice);
   if (ArrayRange(workFil,0)!= Bars) ArrayResize(workFil,Bars); i = Bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (int k=0;  k<period && (i-k)>=0; k++) stddev += MathPow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = MathSqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if( MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
   return(workFil[i][instanceNo+_fprice]);
}

//
//
//
//
//

void createLine(string add, double lrs, double lre, int i, int lineWidth=0)
{
   string name = UniqueID+":"+add+(string)i;
   ObjectCreate(0,name,OBJ_TREND,0,0,0);
      ObjectSet(name,OBJPROP_TIME1,Time[i]);
      ObjectSet(name,OBJPROP_TIME2,Time[i+LrcPeriod-1]);
      ObjectSet(name,OBJPROP_PRICE1,lrs);
      ObjectSet(name,OBJPROP_PRICE2,lre);
      ObjectSet(name,OBJPROP_SELECTABLE,false);
      ObjectSet(name,OBJPROP_RAY,false);
      ObjectSet(name,OBJPROP_BACK,true);
      ObjectSet(name,OBJPROP_HIDDEN,true);
      ObjectSet(name,OBJPROP_WIDTH,lineWidth);
      ObjectSet(name,OBJPROP_STYLE,ChannelStyle);
            color  theColor = ColorDown;
               if (lrs>lre) theColor = ColorUp;
               ObjectSet(name,OBJPROP_COLOR,theColor);
}

//
//
//
//
//

double workLr[];
double iLrValue(double value, int period, double& tslope, double& error, int r)
{
   if (ArraySize(workLr)!=Bars) ArrayResize(workLr,Bars); r = Bars-r-1; workLr[r] = value;
   if (r<period || period<2) return(value);

   //
   //
   //
   //
   //

      double sumx=0, sumxx=0, sumxy=0, sumy=0, sumyy=0;
         for (int k=0; k<period; k++)
         {
            double price = workLr[r-k];
                   sumx  += k;
                   sumxx += k*k;
                   sumxy += k*price;
                   sumy  +=   price;
                   sumyy +=   price*price;
         }
         tslope = (period*sumxy-sumx*sumy)/(sumx*sumx-period*sumxx);
         error  = MathSqrt((period*sumyy-sumy*sumy-tslope*tslope*(period*sumxx-sumx*sumx))/(period*(period-2)));

   //
   //
   //
   //
   //
         
   return((sumy + tslope*sumx)/period);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}